#ifndef TIMER_UTIL_CLASS_H
#define TIMER_UTIL_CLASS_H

#include <chrono>
#include <string>
#include "ara/log/logging.h"
#define TIME_MEASUREMENT

using namespace std::chrono;
class Timer
{
public:
#ifdef TIME_MEASUREMENT
    Timer(const std::string &name, float *time_output = nullptr)
        : name_(name), time_output_(time_output)
    {
        time_start_ = 0;
        time_end_ = 0;
        time_start_ = std::chrono::duration_cast<microseconds>(
                          steady_clock::now().time_since_epoch())
                          .count();
    }
    ~Timer()
    {
        time_end_ = std::chrono::duration_cast<microseconds>(
                        steady_clock::now().time_since_epoch())
                        .count();
        float msec = (float)(time_end_ - time_start_) / 1000.f;
        if (time_output_ != nullptr)
        {
            *time_output_ = msec;
            printf("Runtime %s: %f milliseconds\n", name_.c_str(), msec);
        }
    }
#else
    Timer(const std::string &funcName) {}
    ~Timer() {}
#endif
private:
    Timer() {}
    Timer &operator=(const Timer &obj) { return *this; }

private:
    std::string name_;
    uint64_t time_start_;
    uint64_t time_end_;
    float *time_output_;
};
#endif